<?php
/**
 * My Account navigation
 *
 * This template can be overridden by copying it to yourtheme/kkart/myaccount/navigation.php.
 *
 * HOWEVER, on occasion Kkart will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.kkart.com/document/template-structure/
 * @package Kkart\Templates
 * @version 2.6.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

do_action( 'kkart_before_account_navigation' );
?>

<nav class="kkart-MyAccount-navigation">
	<ul>
		<?php foreach ( kkart_get_account_menu_items() as $endpoint => $label ) : ?>
			<li class="<?php echo kkart_get_account_menu_item_classes( $endpoint ); ?>">
				<a href="<?php echo esc_url( kkart_get_account_endpoint_url( $endpoint ) ); ?>"><?php echo esc_html( $label ); ?></a>
			</li>
		<?php endforeach; ?>
	</ul>
</nav>

<?php do_action( 'kkart_after_account_navigation' ); ?>
